unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, ComCtrls, Buttons, Crt, (*Beachte KeyPreview im Formular*)
  Process;

type

  { TFormsimpleGUIaktualisierung }

  TFormsimpleGUIaktualisierung = class(TForm)
    BitBtnStart: TBitBtn;
    ButtonBupgradable: TButton;
    ButtonBinstalled: TButton;
    ButtonBrpi: TButton;
    ButtonT7: TButton;
    ButtonT4: TButton;
    ButtonT5: TButton;
    ButtonAbbruch: TButton;
    ButtonT3: TButton;
    ButtonT2: TButton;
    ButtonT1: TButton;
    ButtonT6: TButton;
    ButtonT8: TButton;
    EditB1: TEdit;
    EditB2: TEdit;
    EditBefehl: TEdit;
    EditB3: TEdit;
    EditB4: TEdit;
    EditB5: TEdit;
    LabelBefehl1: TLabel;
    LabelBefehl2: TLabel;
    LabelBefehl: TLabel;
    LabelBefehl3: TLabel;
    LabelBefehl4: TLabel;
    LabelBefehl5: TLabel;
    MemoAnleitung: TMemo;
    PanelComputer: TPanel;
    Process: TProcess;
    StatusBar: TStatusBar;
    procedure BitBtnStartClick(Sender: TObject);
    procedure ButtonAbbruchClick(Sender: TObject);
    procedure ButtonBinstalledClick(Sender: TObject);
    procedure ButtonBrpiClick(Sender: TObject);
    procedure ButtonBupgradableClick(Sender: TObject);
    procedure ButtonT1ChangeBounds(Sender: TObject);
    procedure ButtonT2Click(Sender: TObject);
    procedure ButtonT3Click(Sender: TObject);
    procedure ButtonT4Click(Sender: TObject);
    procedure ButtonT5Click(Sender: TObject);
    procedure ButtonT6Click(Sender: TObject);
    procedure ButtonT7Click(Sender: TObject);
    procedure ButtonT8Click(Sender: TObject);
    procedure EditB1Change(Sender: TObject);
    procedure EditB2Change(Sender: TObject);
    procedure EditB3Change(Sender: TObject);
    procedure EditB4Change(Sender: TObject);
    procedure EditB5Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Befehl(Sender: TObject);

  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  FormsimpleGUIaktualisierung: TFormsimpleGUIaktualisierung;

  TextDatei:                   TextFile;
  TextZeile:                   string;

const
  Apostroph=#39;

implementation

{$R *.lfm}

{ TFormsimpleGUIaktualisierung }

(*--------------------------- StartBedingungen -------------------------------*)

procedure TFormsimpleGUIaktualisierung.FormCreate(Sender: TObject);

begin
  AssignFile(TextDatei,'/tmp/simpleGUIaktualisierung.sh');                      // /tmp
  Try                                                                           // Anlegen Skript für Rechte einstellen
    Rewrite(TextDatei);                                                         // hier günstig, da Rechte bei Rewrite erhalten bleiben!
    Except
      ShowMessage('Skript simpleGUIaktualisierung.sh kann nicht anlegen werden! Bitte Verzeichnisse und Rechte prüfen!');
      Halt;
  end;

  TextZeile:='#!/bin/bash';
  WriteLN(Textdatei,TextZeile);
  CloseFile(TextDatei);

  Process.CommandLine:='chmod 777 /tmp/simpleGUIaktualisierung.sh';             // Recht einstellen /tmp
  Process.Active:=true;                                                         // eigentlicher Aufruf

  StatusBar.Panels[0].Text:='Programm simpleGUIaktualisierung gestartet. Die Voreinstellungen sind optimal!';
end;

(*--------------------------- Befehl -----------------------------------------*)

procedure TFormsimpleGUIaktualisierung.Befehl(Sender: TObject);

Begin
//  ShowMessage('Befehl');
  EditBefehl.Text:='';

  If EditB1.Text <> '' then
    Begin
      EditBefehl.Text:=EditB1.Text;
      If EditB2.Text <> '' then EditBefehl.Text:=Editbefehl.Text+' && ';
    End;
  If EditB2.Text <> '' then
    Begin
      EditBefehl.Text:=Editbefehl.Text+' '+EditB2.Text;
      If EditB3.Text <> '' then EditBefehl.Text:=Editbefehl.Text+' && ';
    End;
  If EditB3.Text <> '' then
    Begin
      EditBefehl.Text:=Editbefehl.Text+' '+EditB3.Text;
      If EditB4.Text <> '' then EditBefehl.Text:=Editbefehl.Text+' && ';
    End;
  If EditB4.Text <> '' then
    Begin
      EditBefehl.Text:=Editbefehl.Text+' '+EditB4.Text;
      If EditB5.Text <> '' then EditBefehl.Text:=Editbefehl.Text+' && ';
    End;
  If EditB5.Text <> '' then EditBefehl.Text:=Editbefehl.Text+' '+EditB5.Text;
End;

(*--------------------------- Befehl 1 ---------------------------------------*)

procedure TFormsimpleGUIaktualisierung.EditB1Change(Sender: TObject);
begin
//  ShowMessage('Befehl 1');
  Befehl(Sender);
  StatusBar.Panels[0].Text:='Befehl 1 geändert.';
end;

(*--------------------------- Befehl 2 ---------------------------------------*)

procedure TFormsimpleGUIaktualisierung.EditB2Change(Sender: TObject);
begin
  Befehl(Sender);
  StatusBar.Panels[0].Text:='Befehl 2 geändert.';
end;

(*--------------------------- Befehl 3 ---------------------------------------*)

procedure TFormsimpleGUIaktualisierung.EditB3Change(Sender: TObject);
begin
  Befehl(Sender);
  StatusBar.Panels[0].Text:='Befehl 3 geändert.';
end;

(*--------------------------- Befehl 4 ---------------------------------------*)

procedure TFormsimpleGUIaktualisierung.EditB4Change(Sender: TObject);
begin
  Befehl(Sender);
  StatusBar.Panels[0].Text:='Befehl 4 geändert.';
end;

(*--------------------------- Befehl 5 ---------------------------------------*)

procedure TFormsimpleGUIaktualisierung.EditB5Change(Sender: TObject);
begin
  Befehl(Sender);
  StatusBar.Panels[0].Text:='Befehl 5 geändert.';
end;

(*--------------------------- ein/aus ----------------------------------------*)

procedure TFormsimpleGUIaktualisierung.ButtonT1ChangeBounds(Sender: TObject);
begin
  If ButtonT1.Caption = 'aus' Then
    Begin;
      EditB1.Text := ''; ButtonT1.Caption := 'ein'
    end                       Else
    Begin
      EditB1.Text := 'sudo apt update'; ButtonT1.Caption := 'aus'
    End;
  StatusBar.Panels[0].Text:='Befehl 1 in "'+ButtonT1.Caption+'" geändert.';
End;

procedure TFormsimpleGUIaktualisierung.ButtonT2Click(Sender: TObject);
begin
  If ButtonT2.Caption = 'aus' Then
     Begin;
       EditB2.Text := ''; ButtonT2.Caption := 'ein'
     end                      Else
     Begin
       EditB2.Text := 'sudo apt dist-upgrade'; ButtonT2.Caption := 'aus'
     End;
   StatusBar.Panels[0].Text:='Befehl 2 in "'+ButtonT2.Caption+'" geändert.';
end;

procedure TFormsimpleGUIaktualisierung.ButtonT3Click(Sender: TObject);
begin
  If ButtonT3.Caption = 'aus' Then
     Begin;
       EditB3.Text := ''; ButtonT3.Caption := 'ein'
     end                      Else
     Begin
       EditB3.Text := 'sudo apt autoremove --purge'; ButtonT3.Caption := 'aus'
     End;
   StatusBar.Panels[0].Text:='Befehl 3 in "'+ButtonT3.Caption+'" geändert.';
end;

procedure TFormsimpleGUIaktualisierung.ButtonT4Click(Sender: TObject);
begin
  If ButtonT4.Caption = 'aus' Then
     Begin;
       EditB4.Text := ''; ButtonT4.Caption := 'ein'
     end                      Else
     Begin
       EditB4.Text := 'sudo apt autoclean'; ButtonT4.Caption := 'aus'
     End;
   StatusBar.Panels[0].Text:='Befehl 4 in "'+ButtonT4.Caption+'" geändert.';
end;

procedure TFormsimpleGUIaktualisierung.ButtonT5Click(Sender: TObject);
begin
  If ButtonT5.Caption = 'aus' Then
     Begin;
       EditB5.Text := ''; ButtonT5.Caption := 'ein'
     end                      Else
     Begin
       EditB5.Text := 'sudo apt clean'; ButtonT5.Caption := 'aus'
     End;
   StatusBar.Panels[0].Text:='Befehl 5 in "'+ButtonT5.Caption+'" geändert.';
end;

procedure TFormsimpleGUIaktualisierung.ButtonT6Click(Sender: TObject);
begin
  If ButtonT6.Caption = 'ein' Then
     Begin;
       EditBefehl.Text:='apt list --installed';
       ButtonT6.Caption := 'aus'; ButtonT7.Caption := 'ein'; ButtonT8.Caption := 'ein';

     end                      Else
       FormCreate(Sender);
   StatusBar.Panels[0].Text:='Befehl "apt list --installed" geändert.';
end;

procedure TFormsimpleGUIaktualisierung.ButtonT7Click(Sender: TObject);
begin
  If ButtonT7.Caption = 'ein' Then
     Begin;
       EditBefehl.Text:='sudo apt update && apt list --upgradable';
       ButtonT7.Caption := 'aus'; ButtonT6.Caption := 'ein'; ButtonT8.Caption := 'ein';
     end                      Else
       FormCreate(Sender);
   StatusBar.Panels[0].Text:='Befehl "sudo apt list update & apt list --upgradable" geändert.';
end;

procedure TFormsimpleGUIaktualisierung.ButtonT8Click(Sender: TObject);
begin
  If ButtonT8.Caption = 'ein' Then
       Begin;
         EditBefehl.Text:='sudo rpi-update';
         ButtonT8.Caption := 'aus'; ButtonT6.Caption := 'ein'; ButtonT7.Caption := 'ein';
       end                      Else
         FormCreate(Sender);
     StatusBar.Panels[0].Text:='Befehl "sudo rpi-update" geändert.';
end;

(*--------------------------- list installed ---------------------------------*)

procedure TFormsimpleGUIaktualisierung.ButtonBinstalledClick(Sender: TObject);
begin
  EditBefehl.Text:='apt list --installed';
  ButtonT6.Caption := 'aus'; ButtonT7.Caption := 'ein'; ButtonT8.Caption := 'ein';
  StatusBar.Panels[0].Text:='Befehl "apt list --installed" gewählt.';
end;

(*--------------------------- list upgradable --------------------------------*)

procedure TFormsimpleGUIaktualisierung.ButtonBupgradableClick(Sender: TObject);
begin
  EditBefehl.Text:='sudo apt update && apt list --upgradable';
  ButtonT7.Caption := 'aus'; ButtonT6.Caption := 'ein'; ButtonT8.Caption := 'ein';
  StatusBar.Panels[0].Text:='Befehl "sudo apt update && apt list --upgradable" gewählt.';
end;

(*--------------------------- rpi --------------------------------------------*)

procedure TFormsimpleGUIaktualisierung.ButtonBrpiClick(Sender: TObject);
begin
  EditBefehl.Text:='sudo rpi-update';
  ButtonT8.Caption := 'aus'; ButtonT6.Caption := 'ein'; ButtonT7.Caption := 'ein';
  StatusBar.Panels[0].Text:='Befehl "sudo rpi-update" gewählt.';
end;

(*--------------------------- Aktualisierung ---------------------------------*)

procedure TFormsimpleGUIaktualisierung.BitBtnStartClick(Sender: TObject);
begin
  If EditBefehl.Text = '' Then
    Begin
      MessageDlg('Fehler: Kein Befehl eingegeben!',mtInformation,[mbOK],0);
      FormCreate(Sender);
    end                   Else
  Begin
    Try                                                                         // Anlegen Skript
      Rewrite(TextDatei);
      Except
        ShowMessage('Skript simpleGUIaktualisierung.sh kann nicht anlegen werden! Bitte Verzeichnisse und Rechte prüfen!');
        Halt;
    end;

    TextZeile:='#!/bin/bash';
    WriteLN(TextDatei,TextZeile);
    TextZeile:='# 03.10.2014 - Freiheit   ><>';
    WriteLN(Textdatei,TextZeile);
    TextZeile:='echo Start Skript simpleGUIaktualisierung.sh - Bitte haben Sie etwas Geduld!';
    WriteLN(Textdatei,TextZeile);
    TextZeile:='echo Befehl: '+EditBefehl.Text;
//    ShowMessage('Befehl: '+EditBefehl.Text);
    WriteLN(Textdatei,TextZeile);
    TextZeile:='echo';
    WriteLN(Textdatei,TextZeile);

    TextZeile:=EditBefehl.Text;
    WriteLN(Textdatei,TextZeile);

    TextZeile:='echo';
    WriteLN(Textdatei,TextZeile);
    TextZeile:='echo Ende Skript simpleGUIaktualisierung.sh - Danke für die Benutzung!';
    WriteLN(Textdatei,TextZeile);

    CloseFile(TextDatei);
    ButtonAbbruch.Enabled := true;
//    ShowMessage('Haltepunkt nach Rewrite einstellen');
    Process.CommandLine:='xterm -hold -sb -right -geometry 180x50 -e /tmp/./simpleGUIaktualisierung.sh';
    Process.Active:=true;                                                       // eigentlicher Aufruf

    StatusBar.Panels[0].Text:='Suche gestartet. Gedrückte Maustaste im Terminal-Fenster hält Suche an! Click auf x im Terminal-Fenster beendet Suche!   ><>';
  end;
end;

(*--------------------------- Abbruch ----------------------------------------*)

procedure TFormsimpleGUIaktualisierung.ButtonAbbruchClick(Sender: TObject);
begin
  Process.Active:=false;
  ButtonAbbruch.Enabled:=false;
  StatusBar.Panels[0].Text:='Ende / Abbruch angefordert.';
end;

end.

